import math

def nCr(n,r): #Computes n choose r
    f = math.factorial
    return f(n) / f(r) / f(n-r)
    
def change_HQD(coeff): # coeff is 1-dim array [a_0, a_1, ..., a_n] the polynomial a_0+a_1z+a_2z^2+...+a_nz^n
    degree=len(coeff)-1 #length of the array is n+1, where n is the degree
    if (coeff[degree]==1 and coeff[degree-1]==0):
        return coeff
    else:
        if (coeff[degree]!=1):
            b=pow(coeff[degree], 1/(degree+2))
            for k in range(degree):
                coeff[k]=coeff[k]/pow(b,k+2)
            coeff[degree]=1
        if (coeff[degree-1]!=0):
            c=coeff[degree-1]/degree     #c=a_(n-1)/n
            copy_coeff=coeff.copy()
            for q in range(degree):
                k=q
                sum=0
                while k<=degree:
                    sum=sum+nCr(k,q)*copy_coeff[k]*((-c)**(k-q))
                    k=k+1
                    coeff[q]=sum
                coeff[degree-1]=0
    return coeff


